% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find_example_simulated_networks.R
\name{find_example_simulated_network}
\alias{find_example_simulated_network}
\title{Find an example simulated network that is the minimum Frobenius  distance from the observed network.}
\usage{
find_example_simulated_network(GERGM_Object, observed_network,
  objective = c("Frobenius", "Likelihood"))
}
\arguments{
\item{GERGM_Object}{The object returned by the estimation procedure using the
GERGM function.}

\item{observed_network}{The observed network used as the dependent variable
in the original gergm() specification.}

\item{objective}{Defaults to "Frobenius", in which case the Frobenius norm
is used to find the simulated network that is most similar to the observed
network. Can also be "Likelihood", in which case the model log likelihood is
used to select the network to display.}
}
\value{
A simulated network (as a matrix object).
}
\description{
Find an example simulated network that is the minimum Frobenius  distance from the observed network.
}
